# Operators

## Base operators (@since 1.0.0)

XdY (INT, INT) -> INT[]
- roll X dice with bounds [1, Y]

X+Y (INT, INT) -> INT
- sum X and Y
X+Y (INT[], INT) -> INT[]
- appends Y to X

X-Y (INT, INT) -> INT
- subtract Y from X 
X-Y (INT[], INT) -> INT[]
- appends -Y to X

X*Y (INT, INT) -> INT
- multiply X and Y
X*Y (INT[], INT) -> INT[]
- multiply every element of X by Y

X/Y (INT, INT) -> INT
- divide X by Y, round
X/Y (INT[], INT) -> INT[]
- divide every element of X by Y, round

X//Y (INT, INT) -> INT
- divide X by Y, floor
X//Y (INT[], INT) -> INT[]
- divide every element of X by Y, floor

X^Y (INT, INT) -> INT
- return highest of X and Y
X^Y (INT[], INT) -> INT[]
- return Y highest INTs from X

X_Y (INT, INT) -> INT
- returns lowest of X and Y
X_Y (INT[], INT) -> INT[]
- return Y lowest INTs from X

[X] INT -> INT
- identity
[X] INT[] -> INT
- sums elements of array

## Future

- Explosive rolls (XdY!)
- Compounding rolls (XdY!!)

# Data Types

- Integer
- Integer[] (dynamic)

# Precedence ordering

1) ()
2) XdY
3) ^
4) _
5) /
6) //
7) *
8) +
9) -

(1+2*3)-4
Sub(
    Paren("1+2*3"),
    4
)

Sub(
    Paren(
        Mul(
            "1+2",
            3
        )
    ),
    4
)


Sub(
    Paren(
        Mul(
            Add(
                1,
                2
            ),
            3
        )
    ),
    4
)

ProtoAst
    Expr
    TOkenStream